
/*
Copyright 2007 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of prefswitch.

Prefswitch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Prefswitch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with prefswitch; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function Switch(name, show, preference, initial, type, tooltipPrefix)
{
	this.name           = name;
	this.show           = show;
	this.preference     = preference;
	this.initial        = initial;
	this.type           = type;
	this.tooltipPrefix  = tooltipPrefix;
	this.states         = [];

	this.addState = function(value, description, tooltipPostfix, color)
	{
		this.states[this.states.length] = [value, description, tooltipPostfix, color];
	};

	this.removeState = function(index)
	{
		var tmpStates = [];
		for (var i = 0, j = 0; i < this.states.length; i++)
			if (i != index) tmpStates[j++] = this.states[i];
		this.states = tmpStates;
	};

// -----------------------------------------------------------------------------

	this.getTooltiptextByValue = function(value)
	{
		if (value == null || this.states.length == 0) return "";
		var tooltipPostfix = "";
		for (var i = 0; i < this.states.length; i++)
			if (this.states[i][0] == "" + value && this.tooltipPrefix != "" && this.states[i][2] != "")
				return this.tooltipPrefix + " " + this.states[i][2];
		return "";
	};

	this.getColorByValue = function(value)
	{
		if (value == null || this.states.length == 0) return "";
		for (var i = 0; i < this.states.length; i++)
			if (this.states[i][0] == "" + value) return this.states[i][3];
		return "";
	};

	this.getPrefRoot = function()
	{
		var lindex = this.preference.lastIndexOf(".");
		return this.preference.substring(0, lindex + 1);
	};

	this.getPreference = function()
	{
		var lindex = this.preference.lastIndexOf(".");
		return this.preference.substring(lindex + 1);
	};

	this.isHidden = function()
	{
		return this.show == "false" || this.preference == "" || this.initial == "" || this.states.length <= 0;
	};

	this.getStates = function()
	{
		return this.states;
	};
}
